#include <process.h>
#include <windows.h>

int array[100][100];
SRWLOCK lock;

unsigned int __stdcall  update( void *param )
{
  for (int y=0; y<100; y++)
    for (int x=0; x<100; x++)
    {
      AcquireSRWLockExclusive( &lock );
      array[x][y]++;
      array[y][x]--;
      ReleaseSRWLockExclusive( &lock );
    }
  return 0;
}

unsigned int __stdcall  read( void * param )
{
  int value=0;
  for (int y=0; y<100; y++)
    for (int x=0; x<100; x++)
    {
      AcquireSRWLockShared( &lock );
      value = array[x][y] + array[y][x];
      ReleaseSRWLockShared( &lock );
    }
  printf( "Value = %i\n", value );
  return value;
}

int _tmain( int argc, _TCHAR* argv[] )
{
   HANDLE h1, h2;
   InitializeSRWLock( &lock );
   h1 = (HANDLE)_beginthreadex( 0, 0, &update, (void*)0, 0, 0);
   h2 = (HANDLE)_beginthreadex( 0, 0, &read,   (void*)0, 0, 0);
   WaitForSingleObject( h1, INFINITE );
   WaitForSingleObject( h2, INFINITE );
   CloseHandle( h1 );
   CloseHandle( h2 );
   getchar();
   return 0;
}
