#include <omp.h>

omp_lock_t lock;

double calc( double* array, int length )
{
  double total = 0.0;
  #pragma omp parallel for 
  for ( int i=0; i<length; i++ )
  {
    omp_set_lock( &lock );
    total += array[i];
    omp_unset_lock( &lock );
  }
  return total;
}

void main()
{
  double array[1024];
  omp_init_lock( &lock );
  calc( array, 1024 );
  omp_destroy_lock( &lock );
}
