#include <stdio.h>

#ifdef __sparc
int CAS( volatile int* addr, int ov, int nv)
{
  asm volatile( "cas %1, %2, %0": 
                "=r"(nv): 
                "m"(*addr),"r"(ov),"0"(nv):
                "memory" );
  return nv;
}
#else
int CAS( volatile int* addr, int ov, int nv )
{
  asm volatile( "lock; cmpxchg %2, %1":
                "=a"(ov):
                "m"(*addr),"r"(nv),"a"(ov):
                "memory" );
  return ov;
}
#endif

void lock_spinlock( volatile int *  lock )
{
  while ( CAS(lock, 0, 1) != 0 ) {} // Spin until lock acquired
}

void free_spinlock( volatile int * lock )
{
  *lock = 0;
}

int main()
{
  int lock=0;
  printf("lock = %i\n", lock );
  lock_spinlock( &lock );
  printf("lock = %i\n", lock );
  free_spinlock( &lock );
  printf("lock = %i\n", lock );

}
