#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/time.h>

double now()
{
  struct timeval time;
  gettimeofday( &time, 0 );
  return (double)time.tv_sec + (double)time.tv_usec / 1000000.0;
}

#define COUNT 100000000
volatile int go = 0;
volatile int counters[20];

void *spin( void *id )
{
  int myid = (int)id + 1;
  while( !go ) {}
  counters[myid] = 0;
  while ( counters[myid]++ < COUNT ) {}
}

int main( int argc, char* argv[] )
{
  pthread_t threads[256];
  int nthreads = 1;
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  for( int i=1; i<nthreads; i++ )
  {
    pthread_create( &threads[i], 0, spin, (void*)i );
  }

  double start = now();
  go = 1;
  spin( 0 );
  double end = now();
  printf("Time %f s\n", ( end - start ) );

  for( int i=0; i<nthreads; i++ )
  {
    pthread_join( threads[i], 0 );
  }
  return 0;
}
