#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

pthread_barrier_t barrier;

void* threadcode( void* param )
{
  int stack;
  printf("Stack base address = %x for thread %i\n", &stack, (int)param);
  pthread_barrier_wait( &barrier );
}


int main( int argc, char*argv[] )
{
  pthread_t threads[20];
  int nthreads = 8;
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  pthread_barrier_init( &barrier, 0, nthreads );
  for( int i=0; i<nthreads; i++ ) 
  { 
     pthread_create( &threads[i], 0, threadcode, (void*)i ); 
  }
  for( int i=0; i<nthreads; i++ ) 
  { 
    pthread_join( threads[i], 0 ); 
  }
  pthread_barrier_destroy( &barrier );
  return 0;
}
